<script context="module">
	/**
	 * @type {import('@sveltejs/kit').Load}
	 */
	export async function load({ page, fetch, session, context }) {
		return {
            props: {
                categoryId: page.params.id
            }
		}
	}
</script>

<script lang="ts">
    import { goto } from "$app/navigation";
    import TagInput from "$lib/forms/TagInput.svelte";
    import { onMount } from "svelte";

    import type { Category } from "$lib/api/categories";
    import type { PlaylistListing } from "$lib/api/playlists";

    import { getCategory, updateCategory } from "$lib/api/categories";
    import { listPlaylists } from "$lib/api/playlists";

    import Button from "@smui/button";
    import Textfield from "@smui/textfield";
    import List, { Item, Label } from "@smui/list";
    import Checkbox from "@smui/checkbox";
    import LinearProgress from "@smui/linear-progress";

    export let categoryId: string;
    let category: Category = null;

    let playlists: PlaylistListing[] = [];
    let playlistsMap = [];

    onMount(async () => {
        category = await getCategory(categoryId);
        playlists = await listPlaylists();
        for (let playlist of playlists) playlistsMap.push({label: playlist.title, value: playlist.id});
        playlistsMap = playlistsMap;
    });
</script>

<header>
    <h2 class="mdc-typography--headline4">Edit Category</h2>
</header>

{#if category == null}
    <LinearProgress indeterminate />
{:else}
    <div class="form">
        {#each Object.keys(category.labels) as label}
            <div class="input-group">
                <Textfield bind:value={category.labels[label]} label="Label ({label})"></Textfield>
            </div>
        {/each}

        <div class="input-group">
            <label class="mdc-typography--subtitle2">Tags</label>
            <TagInput bind:tags={category.tags} />
        </div>

        <div class="input-group">
            <List checkList>
                {#each playlistsMap as p}
                    <Item>
                        <Checkbox bind:group={category.playlists} value={p.value} />
                        <Label>{p.label}</Label>
                    </Item>
                {/each}
            </List>
        </div>

        <div class="input-group">
            <Button color="secondary" on:click={() => {goto("/categories");}}>Cancel</Button>
            <Button variant="unelevated" on:click={async () => {
                category = await updateCategory(categoryId, category);
                goto("/categories");
            }}>Save</Button>
        </div>
    </div>

    <!-- <pre>{JSON.stringify(category, null, 2)}</pre> -->
{/if}

<style type="text/scss">
    .input-group {
        margin-bottom: 1rem;
    }
</style>
